package ObservuPlugins::SystemDiskUsage;



# create a new plugin object
sub new {
    my $class = shift;
    my $self = {
      _config => shift,
      _state => {}
    };
    bless $self, $class;
    return $self;
}


# return a hash with all produced metrics
sub produce_data{
  my($self) = @_;
  
  return read_diskusage();  
}


sub read_diskusage {
  my $result = {};
  
  my @lines = split("\n", `df -PTB 1024 -x tmpfs -x proc`);

  my $i=0;
  foreach my $line (@lines) {
    if($i++==0){
      next;
    }
    my ($dev, $type, $blocks, $used, $available) = split(" ", $line);
    
    $result->{"disk.".$dev.".used:kilobytes"} = $used; 
    $result->{"disk.".$dev.".available:kilobytes"} = $available; 
    $result->{"disk.".$dev.".usage:percentage"} = (100*$used)/($used+$available); 
  }
  
  
  return $result;
}
