package ObservuPlugins::SystemNetworkIO;

#### globals for net stats
my @net_fields = ("in:Bps", "out:Bps");
my $net_state = {};
my $net_prev_state = {};
my $net_time = 0;
my $net_prev_time = 0;

# create a new plugin object
sub new {
    my $class = shift;
    my $self = {
      _config => shift,
      _state => {}
    };
    bless $self, $class;
    return $self;
}


# return a hash with all produced metrics
sub produce_data{
  my($self) = @_;
  
  return read_netusage();  
}



sub read_netusage {
  $net_prev_time = $net_time;

  $net_prev_state = $net_state;
  $net_state = {};
  $net_time = time;

  open(my $f, "<", "/proc/net/dev");
  while(defined(my $netline = <$f>)){
    if($netline =~ /^\s*([0-9a-z]+):\s*([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)/){
      #$net_state->{$1} = ($2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,$17);
      if($1 ne "lo" && ($2!="0" || $10!="0")){ # interfaces that never transferred data are probably not interesting
        my @state = ($2, $10); 
        $net_state->{$1} = [@state];
      }
    }
  }
  close($f);

  my $result = {};

  if($net_prev_time > 0){

    my $k;
    foreach $k ( keys %{$net_state} ){
      my @v = @{$net_state->{$k}};
      my @diff = ();
      for(my $i=0; $i<@v; $i++){
        my @vo = @{ $net_prev_state->{$k}};
        $diff[$i] = $v[$i] - $vo[$i];
      }
      for(my $j=0; $j<@net_fields; $j++){
        my $d = $diff[$j];
        my $dt = $net_time - $net_prev_time;
        if($dt > 0 && $d >= 0){
          $result->{"net.".$k.".".$net_fields[$j]} = int($d/$dt);
        }
      }
    }
  }
  
  return $result;
}

